/*
 * ConnectionManager.java
 *
 * Created on 20 de Junho de 2006, 00:44
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package info.everest;

import com.sun.midp.io.Util;
import java.io.DataInput;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import javax.microedition.io.Connector;
import javax.microedition.io.HttpConnection;

/**
 * Code based on code originally from Nokia
 * @author Richter
 */
public class ConnectionManager {
  
  /** Creates a new instance of ConnectionManager */
  public ConnectionManager() {
  }
  
  public Object getDataFromServer(int requestID, String url, Object [] params) {
    HttpConnection conn = null;
    DataInputStream is = null;
    String ret = "";
    
    try {
      String toCall = url;

      System.out.println("Call "+toCall);
      conn = connect(toCall, HttpConnection.POST);

      DataOutputStream output = conn.openDataOutputStream();

      writeObject(output, this);

      /* Write the byte signifying that only one call
       * is being made.
       */
      output.writeShort(1 /* one call to be made to the server */);
      output.writeInt(requestID); // method chamado

      for (int i = 0; i < params.length; i++ ) {
          writeObject(output, params[i]);
      }

      output.flush();
      output.close();

      is = conn.openDataInputStream();
      Object returnValue = readObject(is);
        
      System.out.println("ret: "+returnValue);
      return returnValue;
    } catch(Exception e) {
      e.printStackTrace();
      StringBuffer sb = new StringBuffer();
      sb.append(e.toString());
      sb.append(" ==> ");
      sb.append(e.getMessage());

      return sb.toString();
    } finally {
      if(is!=null) {
        try {
          is.close();
        } catch(Exception ex) {}
      }
      
      if(conn!=null) {
        try {
          conn.close();
        } catch(Exception ex) {}
      }
    }
  }
  
  public static HttpConnection connect(String url, String method) throws IOException {
    HttpConnection conn = null;
    String startlURL = url;
    int tries = 0;
    String lastUrl = null;

    while (url != null && tries < 5) {
      tries++;
      lastUrl = url;
      conn = (HttpConnection) Connector.open(url);
      conn.setRequestMethod(HttpConnection.GET);
      //No need to set User-Agent,
      //this is done automatically for all Series 40 devices
        /*
        conn.setRequestProperty("User-Agent", "Profile/MIDP-2.0 Configuration/CLDC-1.1");
        conn.setRequestProperty("Content-Language","en-US");
         */
      
      int responcecode = conn.getResponseCode();
      switch (responcecode) {
        case HttpConnection.HTTP_MOVED_PERM:
        case HttpConnection.HTTP_MOVED_TEMP:
        case HttpConnection.HTTP_SEE_OTHER:
        case HttpConnection.HTTP_TEMP_REDIRECT:
          url = conn.getHeaderField("Location"); // where should we go?
          
          // Just in case if url is empty
          if (url != null && url.startsWith("/*")) {
            StringBuffer sb = new StringBuffer();
            sb.append("http://");
            sb.append(conn.getHost());
            sb.append(':');
            sb.append(conn.getPort());
            sb.append(url);
            url = sb.toString();
          }

          conn.close();
          break;
        default:
//          System.out.println("Real call goes to "+url);
          url = null;
          break;
      }
    }
    
    if(tries==5 && url != null) {
      throw new RuntimeException("Got over 5 redirects - stopping!");
    }

    InputStream is = conn.openInputStream();
    int toRead = is.available();
    byte [] reading = new byte[toRead];
    is.read(reading);
    is.close();
    conn.close();
    conn = (HttpConnection) Connector.open(lastUrl);
    conn.setRequestMethod(method);
    return conn;
  }
  
    private void writeObject(DataOutputStream out, Object o) throws IOException {
        if (o == this) {
            out.writeShort(1 /* invocation code */);
        } else if (o == null) {
            out.writeShort(-1);
        } else if (o instanceof String) {
            out.writeShort(7 /* STRING_TYPE */);
            out.writeUTF((String) (String) o);
        } else if (o instanceof Boolean) {
            out.writeShort(1 /* BOOLEAN_TYPE */);
            out.writeBoolean(((Boolean) o).booleanValue());
        } else {
            // default if a data type is not supported
            throw new IllegalArgumentException(
                "Unsupported parameter type: " + o.getClass());
        }
    }
  
    private Object readObject(DataInputStream in) throws IOException {
        int type = in.readShort();
        int length;
        switch (type) {
            case 1 /* BOOLEAN_TYPE */:
                return new Boolean(in.readBoolean());
            case -1: /* NULL */
                return null;
        }

        throw new IllegalArgumentException("Unsupported return type (" + type + ")");
    }

}
